package com.hgwebservice.service.syncCdm2;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.hgwebservice.dal.dataobject.data.OperatorDataDO;
import com.hgwebservice.dal.dataobject.data.PatientDataDO;
import com.hgwebservice.dal.mysql.data.OperatorDataMapper;
import com.hgwebservice.dal.mysql.data.PatientDataMapper;
import com.hgwebservice.entity.hisview.OperatorData;
import com.hgwebservice.entity.hisview.PatientData;
import com.hgwebservice.service.HgWebService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class SyncPatientDataByDeptCodeImpl implements SyncPatientDataByDeptCode {
    @Autowired
    OperatorDataMapper operatorDataMapper;
    @Autowired
    HgWebService hgWebService;
    @Value("${hospital_id}")
    private Integer hospitalId;
    @Override
    public void saveCdm2() {
        List<OperatorDataDO> operatorDataDOS = operatorDataMapper.selectList(new LambdaQueryWrapper<>());
//        if (CollUtil.isNotEmpty(operatorDataDOS)){
//            List<String> collect = operatorDataDOS.stream().map(OperatorDataDO::getDeptCode).distinct().collect(Collectors.toList());
//            if (CollUtil.isNotEmpty(collect)){
//                for (String deptCode : collect) {
//                    List<PatientData> patientData = hgWebService.getPatientDataByDeptCode(deptCode);
//                    if (CollUtil.isNotEmpty(patientData)){
//                        List<PatientDataDO> patientDataDOS = BeanUtil.copyToList(patientData, PatientDataDO.class);
//                        operatorDataMapper.replacePatientData(patientDataDOS,hospitalId);
//                    }
//                }
//            }
//        }
        List<PatientData> patientData = hgWebService.getPatientDataByDeptCode("55");
        if (CollUtil.isNotEmpty(patientData)){
            List<PatientDataDO> patientDataDOS = BeanUtil.copyToList(patientData, PatientDataDO.class);
            operatorDataMapper.replacePatientData(patientDataDOS,hospitalId);
        }
    }
}
